%%% Explicit outer loop MPC controller design.
%%% This is only a basic example to show how to proceed 

%% Grneral controller setup

%Inner loop sampling time
Ts=0.1;
%model recall
sys=model;
[nx nu]=size(sys.b);
%weights
Q=eye(size(sys.c,1));
R=.1*eye(nu);
%outer loop controller sampling time
sTs=10*Ts;
%system rediscretization
sys=d2d(sys,sTs);

%% Implicit controller design
clear cost interval limits type;
type='track';% reg (regulator)

%leader
cost.T=1e1*R;
cost.rho=inf;
%prediction and control horizons
interval.N=10;
interval.Nu=2;
%controller domain limits
limits.ymax=[60 60 60]'; %x
limits.ymin=-limits.ymax; %x
% 10 meters times supervisor sample time
limits.dumin=-10*sTs*ones(nu,1);
limits.dumax=-limits.dumin;
%implicit MPC controller generation
L=lincon(sys,'track',cost,interval,limits);
% kalman observer generation 
kalman(L);

% %followers
% cost.S=1e2*Q;
% f1L=lincon(sys,'track',cost,interval,limits);
% f2L=f1L;
% kalman(f1L);
% kalman(f2L);

%% Explicit controller design

% controller input/output ranges
clear range;
range.xmin=-60*ones(nx,1);
range.xmax=-range.xmin;
range.umin=limits.dumin;
range.umin=limits.dumin;
%explicit MPC controller generation
expC = expcon(L,range);
%explicit pwag controller
Cpwag=pwag(expC);





